package org.xbib.event;

import java.io.IOException;
import java.nio.file.Path;
import java.time.Instant;

public interface Event {

    boolean isNullEvent();

    Listener getListener();

    String getType();

    String getCode();

    String getMessage();

    Instant getInstant();

    Payload getPayload();

    Path getPath();

    String getBase();

    String getSuffix();

    long getFileSize();

    void success() throws IOException;

    void fail() throws IOException;

    String INCOMING = "incoming";

    String SUCCESS = "success";

    String FAIL = "fail";

    String toJson() throws IOException;
}
