package org.xbib.event.async;

/**
 * This is a general purpose exception class that is often thrown if things go wrong.
 *
 */
public class EventException extends RuntimeException {

  /**
   * Create an instance given a message
   *
   * @param message  the message
   */
  public EventException(String message) {
    super(message);
  }

  /**
   * Create an instance given a message and a cause
   *
   * @param message  the message
   * @param cause  the cause
   */
  public EventException(String message, Throwable cause) {
    super(message, cause);
  }

  /**
   * Create an instance given a cause
   *
   * @param cause  the cause
   */
  public EventException(Throwable cause) {
    super(cause);
  }

  /**
   * Create an instance given a message
   *
   * @param message  the message
   * @param noStackTrace  disable stack trace capture
   */
  public EventException(String message, boolean noStackTrace) {
    super(message, null, !noStackTrace, !noStackTrace);
  }

  /**
   * Create an instance given a message
   *
   * @param message  the message
   * @param cause  the cause
   * @param noStackTrace  disable stack trace capture
   */
  public EventException(String message, Throwable cause, boolean noStackTrace) {
    super(message, cause, !noStackTrace, !noStackTrace);
  }

  /**
   * Create an instance given a message
   *
   * @param cause  the cause
   * @param noStackTrace  disable stack trace capture
   */
  public EventException(Throwable cause, boolean noStackTrace) {
    super(null, cause, !noStackTrace, !noStackTrace);
  }
}
