package org.xbib.event.async.impl.future;

import org.xbib.event.async.impl.ContextInternal;

/**
 * Map value transformation.
 */
class FixedMapping<T, U> extends Operation<U> implements Listener<T> {

  private final U value;

  FixedMapping(ContextInternal context, U value) {
    super(context);
    this.value = value;
  }

  @Override
  public void onSuccess(T value) {
    tryComplete(this.value);
  }

  @Override
  public void onFailure(Throwable failure) {
    tryFail(failure);
  }
}
