package org.xbib.event.async.impl.future;

/**
 * Internal listener that signals success or failure when a future completes.
 */
public interface Listener<T> {

  /**
   * Signal the success.
   *
   * @param value the value
   */
  void onSuccess(T value);

  /**
   * Signal the failure
   *
   * @param failure the failure
   */
  void onFailure(Throwable failure);
}
