package org.xbib.event.async.impl.future;

import org.xbib.event.async.impl.ContextInternal;

import java.util.function.Function;

class Otherwise<T> extends Operation<T> implements Listener<T> {

  private final Function<Throwable, T> mapper;

  Otherwise(ContextInternal context, Function<Throwable, T> mapper) {
    super(context);
    this.mapper = mapper;
  }

  @Override
  public void onSuccess(T value) {
    tryComplete(value);
  }

  @Override
  public void onFailure(Throwable failure) {
    T result;
    try {
      result = mapper.apply(failure);
    } catch (Throwable e) {
      tryFail(e);
      return;
    }
    tryComplete(result);
  }
}
