package org.xbib.event.async.impl.future;

import org.xbib.event.loop.Future;
import org.xbib.event.async.AsyncResult;
import org.xbib.event.async.impl.ContextInternal;

/**
 * Promise implementation.
 */
public final class PromiseImpl<T> extends FutureImpl<T> implements PromiseInternal<T>, Listener<T> {

  /**
   * Create a promise that hasn't completed yet
   */
  public PromiseImpl() {
    super();
  }

  /**
   * Create a promise that hasn't completed yet
   */
  public PromiseImpl(ContextInternal context) {
    super(context);
  }

  public void handle(AsyncResult<T> ar) {
    if (ar.succeeded()) {
      onSuccess(ar.result());
    } else {
      onFailure(ar.cause());
    }
  }

  @Override
  public void onSuccess(T value) {
    tryComplete(value);
  }

  @Override
  public void onFailure(Throwable failure) {
    tryFail(failure);
  }

  @Override
  public org.xbib.event.async.Future<T> future() {
    return this;
  }

  @Override
  public void operationComplete(Future<T> future) {
    if (future.isSuccess()) {
      complete(future.getNow());
    } else {
      fail(future.cause());
    }
  }
}
