package org.xbib.event.async.yield;

/**
 * Bulk traversal.
 * We uses traverse method as its first choice to
 * implement Query operations.
 * This is a special kind of traversal that disallows individually access.
 */
public interface Traverser<T> {
    /**
     * A Traverser object without elements.
     */
    static <R> Traverser<R> empty() {
        return action -> {
        };
    }

    /**
     * Yields elements sequentially in the current thread,
     * until all elements have been processed or an
     * exception is thrown.
     */
    void traverse(Yield<? super T> yield);
}
