package org.xbib.event.async.yield.async;

import org.xbib.event.async.yield.AsyncQuery;

import java.util.concurrent.CompletableFuture;
import java.util.function.BiConsumer;
import java.util.function.Predicate;

public class AsyncQueryFilter<T> extends AsyncQuery<T> {
    private final AsyncQuery<T> upstream;
    private final Predicate<? super T> p;

    public AsyncQueryFilter(AsyncQuery<T> upstream, Predicate<? super T> p) {
        this.upstream = upstream;
        this.p = p;
    }

    @Override
    public CompletableFuture<Void> subscribe(BiConsumer<? super T, ? super Throwable> cons) {
        return upstream.subscribe((item, err) -> {
            if (err != null) {
                cons.accept(null, err);
                return;
            }
            if (p.test(item)) cons.accept(item, null);
        });
    }
}
