package org.xbib.event.async.yield.async;

import org.xbib.event.async.yield.AsyncQuery;

import java.util.concurrent.CompletableFuture;
import java.util.function.BiConsumer;
import java.util.function.Function;

public class AsyncQueryFlatMapConcat<T, R> extends AsyncQuery<R> {

    private final AsyncQuery<T> upstream;

    private final Function<? super T, ? extends AsyncQuery<? extends R>> mapper;

    public AsyncQueryFlatMapConcat(AsyncQuery<T> upstream, Function<? super T, ? extends AsyncQuery<? extends R>> mapper) {
        this.upstream = upstream;
        this.mapper = mapper;
    }

    @Override
    public CompletableFuture<Void> subscribe(BiConsumer<? super R, ? super Throwable> cons) {
        return upstream.subscribe((item, err) -> {
            if (err != null) {
                cons.accept(null, err);
                return;
            }
            mapper.apply(item)
                    .subscribe(cons)
                    .join();
        });
    }
}
