package org.xbib.event.async.yield.async;

import org.xbib.event.async.yield.AsyncQuery;

import java.util.concurrent.CompletableFuture;
import java.util.function.BiConsumer;

public class AsyncQueryOnNext<T> extends AsyncQuery<T> {

    private final AsyncQuery<T> upstream;

    private final BiConsumer<? super T, ? super Throwable> action;

    public AsyncQueryOnNext(AsyncQuery<T> upstream, BiConsumer<? super T, ? super Throwable> action) {
        this.upstream = upstream;
        this.action = action;
    }

    @Override
    public CompletableFuture<Void> subscribe(BiConsumer<? super T, ? super Throwable> cons) {
        return upstream.subscribe((item, err) -> {
            action.accept(item, err);
            cons.accept(item, err);
        });
    }
}
