package org.xbib.event.async.yield.primitives.dbl.ops;

import org.xbib.event.async.yield.primitives.dbl.DoubleAdvancer;
import org.xbib.event.async.yield.primitives.dbl.DoubleQuery;
import org.xbib.event.async.yield.primitives.dbl.DoubleTraverser;
import org.xbib.event.async.yield.primitives.dbl.DoubleYield;

import java.util.function.DoubleFunction;

public class DoubleFlatMap implements DoubleAdvancer, DoubleTraverser {

    private final DoubleQuery upstream;

    private final DoubleFunction<? extends DoubleQuery> mapper;

    DoubleQuery src;

    public DoubleFlatMap(DoubleQuery query, DoubleFunction<? extends DoubleQuery> mapper) {
        this.upstream = query;
        this.mapper = mapper;
        src = new DoubleQuery(DoubleAdvancer.empty(), DoubleTraverser.empty());
    }

    @Override
    public void traverse(DoubleYield yield) {
        upstream.traverse(elem -> mapper.apply(elem).traverse(yield));
    }

    @Override
    public boolean tryAdvance(DoubleYield yield) {
        while (!src.tryAdvance(yield)) {
            if (!upstream.tryAdvance(t -> src = mapper.apply(t)))
                return false;
        }
        return true;
    }
}
