package org.xbib.event.async.yield.primitives.dbl.ops;

import org.xbib.event.async.yield.primitives.dbl.DoubleAdvancer;
import org.xbib.event.async.yield.primitives.dbl.DoubleTraverser;
import org.xbib.event.async.yield.primitives.dbl.DoubleYield;

import java.util.function.DoubleUnaryOperator;

public class DoubleIterate implements DoubleAdvancer, DoubleTraverser {

    private final DoubleUnaryOperator f;

    private double prev;

    public DoubleIterate(double seed, DoubleUnaryOperator f) {
        this.f = f;
        this.prev = seed;
    }

    /**
     * Continues from the point where tryAdvance or next left the
     * internal iteration.
     *
     * @param yield yield
     */
    @Override
    public void traverse(DoubleYield yield) {
        for (double i = prev; true; i = f.applyAsDouble(i)) {
            yield.ret(i);
        }
    }

    @Override
    public boolean tryAdvance(DoubleYield yield) {
        double curr = prev;
        prev = f.applyAsDouble(prev);
        yield.ret(curr);
        return true;
    }
}
