package org.xbib.event.async.yield.primitives.dbl.ops;

import org.xbib.event.async.yield.primitives.dbl.DoubleAdvancer;
import org.xbib.event.async.yield.primitives.dbl.DoubleQuery;
import org.xbib.event.async.yield.primitives.dbl.DoubleTraverser;
import org.xbib.event.async.yield.primitives.dbl.DoubleYield;

public class DoubleLimit implements DoubleAdvancer, DoubleTraverser {

    private final DoubleQuery upstream;

    private final int n;

    int count;

    public DoubleLimit(DoubleQuery upstream, int n) {
        this.upstream = upstream;
        this.n = n;
        count = 0;
    }

    @Override
    public void traverse(DoubleYield yield) {
        if (count >= n)
            throw new IllegalStateException("Traverser has already been operated on or closed!");
        while (this.tryAdvance(yield)) {
            // Intentionally empty. Action specified on yield statement of tryAdvance().
        }
    }

    @Override
    public boolean tryAdvance(DoubleYield yield) {
        if (count >= n) return false;
        count++;
        return upstream.tryAdvance(yield);
    }
}
