package org.xbib.event.async.yield.primitives.dbl.ops;

import org.xbib.event.async.yield.primitives.dbl.DoubleAdvancer;
import org.xbib.event.async.yield.primitives.dbl.DoubleQuery;
import org.xbib.event.async.yield.primitives.dbl.DoubleTraverser;
import org.xbib.event.async.yield.primitives.dbl.DoubleYield;

import java.util.function.DoubleUnaryOperator;

public class DoubleMapping implements DoubleAdvancer, DoubleTraverser {

    private final DoubleQuery upstream;

    private final DoubleUnaryOperator mapper;

    public DoubleMapping(DoubleQuery adv, DoubleUnaryOperator mapper) {
        this.upstream = adv;
        this.mapper = mapper;
    }

    @Override
    public void traverse(DoubleYield yield) {
        upstream.traverse(e -> yield.ret(mapper.applyAsDouble(e)));
    }

    @Override
    public boolean tryAdvance(DoubleYield yield) {
        return upstream.tryAdvance(item -> yield.ret(mapper.applyAsDouble(item)));
    }
}
