package org.xbib.event.async.yield.primitives.intgr.ops;

import org.xbib.event.async.yield.boxes.BoolBox;
import org.xbib.event.async.yield.primitives.intgr.IntAdvancer;
import org.xbib.event.async.yield.primitives.intgr.IntQuery;
import org.xbib.event.async.yield.primitives.intgr.IntTraverser;
import org.xbib.event.async.yield.primitives.intgr.IntYield;

import java.util.HashSet;

public class IntDistinct implements IntAdvancer, IntTraverser {
    final HashSet<Integer> mem = new HashSet<>();
    private final IntQuery upstream;

    public IntDistinct(IntQuery adv) {
        this.upstream = adv;
    }

    @Override
    public void traverse(IntYield yield) {
        upstream.traverse(item -> {
            if (mem.add(item)) {
                yield.ret(item);
            }
        });
    }

    @Override
    public boolean tryAdvance(IntYield yield) {
        final BoolBox found = new BoolBox();
        while (found.isFalse() && upstream.tryAdvance(item -> {
            if (mem.add(item)) {
                yield.ret(item);
                found.set();
            }
        })) ;
        return found.isTrue();
    }
}
