package org.xbib.event.async.yield.primitives.intgr.ops;

import org.xbib.event.async.yield.boxes.BoolBox;
import org.xbib.event.async.yield.primitives.intgr.IntAdvancer;
import org.xbib.event.async.yield.primitives.intgr.IntQuery;
import org.xbib.event.async.yield.primitives.intgr.IntTraverser;
import org.xbib.event.async.yield.primitives.intgr.IntYield;

import java.util.function.IntPredicate;

public class IntFilter implements IntAdvancer, IntTraverser {
    private final IntQuery upstream;
    private final IntPredicate p;

    public IntFilter(IntQuery adv, IntPredicate p) {
        this.upstream = adv;
        this.p = p;
    }

    @Override
    public void traverse(IntYield yield) {
        upstream.traverse(e -> {
            if (p.test(e)) {
                yield.ret(e);
            }
        });
    }

    @Override
    public boolean tryAdvance(IntYield yield) {
        BoolBox found = new BoolBox();
        while (found.isFalse()) {
            boolean hasNext = upstream.tryAdvance(item -> {
                if (p.test(item)) {
                    yield.ret(item);
                    found.set();
                }
            });
            if (!hasNext) break;
        }
        return found.isTrue();
    }
}
