package org.xbib.event.async.yield.primitives.intgr.ops;

import org.xbib.event.async.yield.primitives.intgr.IntAdvancer;
import org.xbib.event.async.yield.primitives.intgr.IntTraverser;
import org.xbib.event.async.yield.primitives.intgr.IntYield;

import java.util.function.IntSupplier;

public class IntGenerate implements IntAdvancer, IntTraverser {
    private final IntSupplier s;

    public IntGenerate(IntSupplier s) {
        this.s = s;
    }

    @SuppressWarnings("java:S2189")
    @Override
    public void traverse(IntYield yield) {
        while (true) {
            yield.ret(s.getAsInt());
        }
    }

    @Override
    public boolean tryAdvance(IntYield yield) {
        yield.ret(s.getAsInt());
        return true;
    }
}
