package org.xbib.event.async.yield.primitives.lng.ops;

import org.xbib.event.async.yield.primitives.lng.LongAdvancer;
import org.xbib.event.async.yield.primitives.lng.LongTraverser;
import org.xbib.event.async.yield.primitives.lng.LongYield;

public class FromLongArray implements LongAdvancer, LongTraverser {

    private final long[] data;

    private int current;

    public FromLongArray(long... data) {
        this.data = data;
        this.current = 0;
    }

    public boolean hasNext() {
        return current < data.length;
    }

    /**
     * Continues from the polong where tryAdvance or next left the
     * longernal iteration.
     *
     * @param yield yield
     */
    @Override
    public void traverse(LongYield yield) {
        for (int i = current; i < data.length; i++) {
            yield.ret(data[i]);
        }
    }

    @Override
    public boolean tryAdvance(LongYield yield) {
        if (!hasNext()) return false;
        yield.ret(data[current++]);
        return true;
    }
}
