package org.xbib.event.async.yield.primitives.lng.ops;

import org.xbib.event.async.yield.boxes.BoolBox;
import org.xbib.event.async.yield.primitives.lng.LongAdvancer;
import org.xbib.event.async.yield.primitives.lng.LongQuery;
import org.xbib.event.async.yield.primitives.lng.LongTraverser;
import org.xbib.event.async.yield.primitives.lng.LongYield;

import java.util.function.LongPredicate;

public class LongFilter implements LongAdvancer, LongTraverser {
    private final LongQuery upstream;
    private final LongPredicate p;

    public LongFilter(LongQuery adv, LongPredicate p) {
        this.upstream = adv;
        this.p = p;
    }

    @Override
    public void traverse(LongYield yield) {
        upstream.traverse(e -> {
            if (p.test(e)) {
                yield.ret(e);
            }
        });
    }

    @Override
    public boolean tryAdvance(LongYield yield) {
        BoolBox found = new BoolBox();
        while (found.isFalse()) {
            boolean hasNext = upstream.tryAdvance(item -> {
                if (p.test(item)) {
                    yield.ret(item);
                    found.set();
                }
            });
            if (!hasNext) break;
        }
        return found.isTrue();
    }
}
