package org.xbib.event.async.yield.primitives.lng.ops;

import org.xbib.event.async.yield.primitives.lng.LongAdvancer;
import org.xbib.event.async.yield.primitives.lng.LongQuery;
import org.xbib.event.async.yield.primitives.lng.LongTraverser;
import org.xbib.event.async.yield.primitives.lng.LongYield;

import java.util.function.LongFunction;

public class LongFlatMap implements LongAdvancer, LongTraverser {
    private final LongQuery upstream;
    private final LongFunction<? extends LongQuery> mapper;
    LongQuery src;

    public LongFlatMap(LongQuery query, LongFunction<? extends LongQuery> mapper) {
        this.upstream = query;
        this.mapper = mapper;
        src = new LongQuery(LongAdvancer.empty(), LongTraverser.empty());
    }

    @Override
    public void traverse(LongYield yield) {
        upstream.traverse(elem -> mapper.apply(elem).traverse(yield));

    }

    @Override
    public boolean tryAdvance(LongYield yield) {
        while (!src.tryAdvance(yield)) {
            if (!upstream.tryAdvance(t -> src = mapper.apply(t)))
                return false;
        }
        return true;
    }
}
