package org.xbib.event.async.yield.primitives.lng.ops;

import org.xbib.event.async.yield.Yield;
import org.xbib.event.async.yield.boxes.BoolBox;
import org.xbib.event.async.yield.primitives.lng.LongAdvancer;
import org.xbib.event.async.yield.primitives.lng.LongQuery;
import org.xbib.event.async.yield.primitives.lng.LongTraverser;
import org.xbib.event.async.yield.primitives.lng.LongYield;

import java.util.function.LongBinaryOperator;

public class LongZip implements LongAdvancer, LongTraverser {
    private final LongQuery upstream;
    private final LongQuery other;
    private final LongBinaryOperator zipper;

    public LongZip(LongQuery upstream, LongQuery other, LongBinaryOperator zipper) {
        this.upstream = upstream;
        this.other = other;
        this.zipper = zipper;
    }

    @Override
    public void traverse(LongYield yield) {
        upstream.shortCircuit(e1 -> {
            if (!other.tryAdvance(e2 -> yield.ret(zipper.applyAsLong(e1, e2))))
                Yield.bye();
        });
    }

    @Override
    public boolean tryAdvance(LongYield yield) {
        BoolBox consumed = new BoolBox();
        upstream.tryAdvance(e1 -> other.tryAdvance(e2 -> {
            yield.ret(zipper.applyAsLong(e1, e2));
            consumed.set();
        }));
        return consumed.isTrue();
    }
}
