package org.xbib.event.common;

import org.xbib.datastructures.json.tiny.Json;
import org.xbib.event.Payload;

import java.io.IOException;
import java.io.InputStream;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.LinkedHashMap;
import java.util.Map;

@SuppressWarnings("serial")
public class PayloadImpl extends LinkedHashMap<String, Object> implements Payload {

    public PayloadImpl() {
        super();
    }

    public PayloadImpl(Map<String, Object> map) {
        super(map);
    }

    public static PayloadImpl fromPath(Path path) {
        PayloadImpl payload = new PayloadImpl();
        try (InputStream inputStream = Files.newInputStream(path)) {
            String content = new String(inputStream.readAllBytes(), StandardCharsets.UTF_8);
            payload.putAll(Json.toMap(content));
        } catch (IOException e) {
            throw new IllegalArgumentException("broken json content in path " + path);
        }
        return payload;
    }
}
