package org.xbib.event.persistence;

import org.xbib.settings.Settings;

import java.net.URI;
import java.util.Map;

@SuppressWarnings("serial")
public class FilePersistenceStore extends AbstractPersistenceStore {

    public FilePersistenceStore(Settings settings, String name) {
        this(URI.create(settings.get("store.uri", "file:///var/tmp/event/store")),
                Durability.valueOf(settings.get("store.durability", "PERMANENT")),
                settings.get("store.name", name));
    }

    public FilePersistenceStore(URI uri, Durability durability, String storeName) {
        this(new FileJsonCodec(uri), durability, storeName);
    }

    public FilePersistenceStore(Codec<Map<String, Object>> codec, Durability durability, String storeName) {
        super(codec, durability, storeName);
    }
}
