package org.xbib.event.wal;

import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;

/**
 * A wrapper around a DataOutputStream, which wraps a ByteArrayOutputStream.
 * This allows us to obtain the DataOutputStream itself so that we can perform
 * writeXYZ methods and also allows us to obtain the underlying ByteArrayOutputStream
 * for performing methods such as size(), reset(), writeTo()
 */
public class ByteArrayDataOutputStream {
    private final ByteArrayOutputStream baos;
    private final DataOutputStream dos;

    public ByteArrayDataOutputStream(final int initialBufferSize) {
        this.baos = new ByteArrayOutputStream(initialBufferSize);
        this.dos = new DataOutputStream(baos);
    }

    public DataOutputStream getDataOutputStream() {
        return dos;
    }

    public ByteArrayOutputStream getByteArrayOutputStream() {
        return baos;
    }
}
