package org.xbib.event.wal;

public class StandardJournalRecovery implements JournalRecovery {
    private final int updateCount;
    private final long maxTransactionId;
    private final boolean eofException;

    public StandardJournalRecovery(final int updateCount, final long maxTransactionId, final boolean eofException) {
        this.updateCount = updateCount;
        this.maxTransactionId = maxTransactionId;
        this.eofException = eofException;
    }

    @Override
    public int getUpdateCount() {
        return updateCount;
    }

    @Override
    public long getMaxTransactionId() {
        return maxTransactionId;
    }

    @Override
    public boolean isEOFExceptionEncountered() {
        return eofException;
    }
}
